
const KEY = "Drupal.notification.viewed";

let viewedNotifications = localStorage.getItem(KEY) ? localStorage.getItem(KEY).split(',') : [];

drupalSettings.notifications.forEach(notification => {
    if(!viewedNotifications.includes(notification.uuid)) {
        showNotification(notification);
        viewedNotifications.push(notification.uuid);
        localStorage.setItem(KEY, viewedNotifications);
    }
});


document.querySelector('.notification-overlay').addEventListener('click', function() {
    let notifications = document.querySelectorAll('.notification-w');
    let lastNotification = notifications[notifications.length - 1].id;
    closeNotification(lastNotification);
});

document.querySelectorAll('.notification .close').forEach(function(e) {
    e.addEventListener('click', function(e) {
        let uuid = e.target.closest(".notification-w").id;
        closeNotification(uuid);
    });
});


function showNotification(notification) {
    if(!document.querySelector('.notification-overlay')) {
        let overlay = document.createElement('div');
        overlay.classList.add('notification-overlay');
        document.body.appendChild(overlay);
    }

    let popin = document.createElement('div');
    popin.classList.add('notification-w');
    popin.setAttribute('id', notification.uuid);
    popin.innerHTML = notification.content;
    document.body.appendChild(popin);
}


function closeNotification(uuid) {
    document.querySelector('#'+uuid).remove();
    if(!document.querySelector('.notification')) {
        document.querySelector('.notification-overlay').remove();
    }
}